<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:rich="http://richfaces.org/rich"
                xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns="http://www.w3.org/1999/xhtml"
                template="//layout/template.xhtml">
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.webservice.tester.RunASoapUIProject']}"/>
    <ui:define name="body">
        <s:div id="globalDiv">
            <h:form id="formProject">
                <gri:panel>
                    <f:facet name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.TestInstanceRequest']}"/>
                    </f:facet>
                    <s:div id="RequestPanel">
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="selectProject"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.webservice.tester.Project']}</ui:define>
                            <h:selectOneMenu id="selectProject" styleClass="form-control"
                                             value="#{runSoapui.currentProject}" required="true">
                                <f:selectItem itemValue="#{null}" itemLabel="#{messages['net.ihe.gazelle.simulators.PleaseSelect']}"
                                              noSelectionOption="true"/>
                                <f:selectItems value="#{runSoapui.getActiveSoapuiProjects()}" var="uiproject"
                                               itemLabel="#{uiproject.label}"/>
                                <f:converter converterId="soapuiProjectConverter"/>
                                <a4j:ajax event="change" listener="#{runSoapui.softReset}" render="globalDiv"/>
                            </h:selectOneMenu>
                        </s:decorate>

                        <rich:panel styleClass="gzl-alert gzl-alert-red" rendered="#{runSoapui.currentProject != null and !runSoapui.isFileExist()}">
                            <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.TheProjectFileDoesNotExist']}"/>
                        </rich:panel>

                        <s:decorate template="/layout/form/_checkbox.xhtml" rendered="#{runSoapui.isEhealthsuisse()}">
                            <h:selectBooleanCheckbox value="#{runSoapui.runInstance}">
                                <a4j:ajax render="ResultPanelInstance, ResultPanelClassic, footerDiv"/>
                            </h:selectBooleanCheckbox>
                            #{messages['net.ihe.gazelle.webservice.tester.ExecuteATestInstanceeHealthSuisse']})
                        </s:decorate>
                    </s:div>

                    <s:div id="ResultPanelInstance">
                        <s:div rendered="#{runSoapui.runInstance == true and runSoapui.isFileExist()}">

                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="testInstanceId"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.webservice.tester.InstanceID']}</ui:define>
                                <h:inputText id="testInstanceId" value="#{runSoapui.testInstanceId}"
                                             required="true" styleClass="form-control"/>
                            </s:decorate>

                            <s:div rendered="#{runSoapui.execution.testInstanceResult != null}">
                                <gri:panel pid="testInstanceInfoPanel">
                                    <f:facet name="header">
                                        <h:outputText value="#{messages['gazelle.simulator.TestInstance']}"/>
                                    </f:facet>

                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.webservice.tester.TestName']}</ui:define>
                                        <h:outputText value="#{runSoapui.execution.testInstanceResult.testName}"/>
                                    </s:decorate>

                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.webservice.tester.TestKeyword']}</ui:define>
                                        <h:outputText value="#{runSoapui.execution.testInstanceResult.testKeyword}"/>
                                    </s:decorate>

                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.webservice.tester.TestInstancePermanentLink']}</ui:define>
                                        <h:outputLink
                                                value="#{runSoapui.execution.testInstanceResult.getInstanceLink()}"
                                                target="_blank">
                                            #{runSoapui.execution.testInstanceResult.getInstanceLink()}
                                        </h:outputLink>
                                    </s:decorate>

                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.webservice.tester.TestCurrentStatus']}</ui:define>
                                        <h:outputText value="#{runSoapui.execution.testInstanceResult.lastStatus}"/>
                                    </s:decorate>

                                </gri:panel>


                                <gri:panel pid="parameterPanel">
                                    <f:facet name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.Parameters']}"/>
                                    </f:facet>
                                    <div class="form-horizontal">
                                        <a4j:repeat value="#{runSoapui.execution.customPropertiesUsed}"
                                                    var="customPropertyUsed">
                                            <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                                <ui:param name="id" value="parameterInput"/>
                                                <ui:define name="label">#{customPropertyUsed.customProperty.label}
                                                </ui:define>
                                                <h:inputText id="parameterInput" value="#{customPropertyUsed.value}"
                                                             required="true" styleClass="form-control"/>
                                            </s:decorate>
                                        </a4j:repeat>
                                    </div>
                                </gri:panel>
                            </s:div>
                        </s:div>
                    </s:div>

                    <s:div id="ResultPanelClassic">
                        <s:div id="treeProjectPanel" rendered="#{runSoapui.runInstance == false and runSoapui.isFileExist()}">
                            <s:div rendered="#{runSoapui.getCurrentProject() != null and runSoapui.componentToExecute == null}">

                                <rich:panel styleClass="gzl-alert gzl-alert-blue">
                                    <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.SelectTheComponentToExecute']}"/>
                                </rich:panel>

                                <s:div id="treeDiv">

                                    <rich:tree id="treeOfParams" value="#{runSoapui.getProjectAsTree()}" var="node"
                                               selectionChangeListener="#{runSoapui.setCurrentNodeEventAndPrepareExecution2}">
                                        <rich:treeSelectionChangeListener
                                                listener="#{runSoapui.setCurrentNodeEventAndPrepareExecution2}"/>
                                        <rich:treeNode iconExpanded="images/testcase.png"
                                                       iconCollapsed="images/testcase.png"
                                                       rendered="#{node.data.getClass().getSimpleName() == 'GwtTestCase'}"
                                                       expanded="#{node.data.expendedInTree}">
                                            <h:selectBooleanCheckbox rendered="#{node.data.executable}">
                                                <a4j:ajax event="click"
                                                          listener="#{runSoapui.setCurrentNodeEventAndPrepareExecution}"
                                                          render="ResultPanelClassic, footerDiv"/>
                                                <f:attribute name="testComponent" value="#{node.data}"/>
                                            </h:selectBooleanCheckbox>
                                            <h:outputText value="#{node.data.label}"/>
                                        </rich:treeNode>
                                        <rich:treeNode iconExpanded="images/testsuite.png"
                                                       iconCollapsed="images/testsuite.png"
                                                       rendered="#{node.data.getClass().getSimpleName() == 'GwtTestSuite'}"
                                                       expanded="#{node.data.expendedInTree}">
                                            <h:selectBooleanCheckbox rendered="#{node.data.executable}">
                                                <a4j:ajax event="click"
                                                          listener="#{runSoapui.setCurrentNodeEventAndPrepareExecution}"
                                                          render="ResultPanelClassic, footerDiv"/>
                                                <f:attribute name="testComponent" value="#{node.data}"/>
                                            </h:selectBooleanCheckbox>
                                            <h:outputText value="#{node.data.label}"/>
                                        </rich:treeNode>
                                        <rich:treeNode iconExpanded="images/project.png"
                                                       iconCollapsed="images/project.png"
                                                       rendered="#{node.data.getClass().getSimpleName() == 'GwtProject'}"
                                                       expanded="#{node.data.expendedInTree}">
                                            <h:selectBooleanCheckbox rendered="#{node.data.executable}">
                                                <a4j:ajax event="click"
                                                          listener="#{runSoapui.setCurrentNodeEventAndPrepareExecution}"
                                                          render="ResultPanelClassic, footerDiv"/>
                                                <f:attribute name="testComponent" value="#{node.data}"/>
                                            </h:selectBooleanCheckbox>
                                            <h:outputText value="#{node.data.label}"/>
                                        </rich:treeNode>
                                    </rich:tree>
                                </s:div>
                            </s:div>
                            <s:div
                                    rendered="#{runSoapui.getCurrentProject() != null and runSoapui.componentToExecute != null}">

                                <ui:decorate template="/layout/display/_display.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.webservice.tester.ComponentSelected']}</ui:define>
                                    <h:outputText value="#{runSoapui.componentToExecute.label}"/>
                                </ui:decorate>

                                <gri:panel pid="parameterPanel">
                                    <f:facet name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.Parameters']}"/>
                                    </f:facet>

                                    <rich:panel styleClass="gzl-alert gzl-alert-blue"
                                                rendered="#{runSoapui.runInstanceAction.customPropertiesToModifyNull()}">
                                        <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.ThereIsNoCustomPropertyNeededToBeSet']}"/>
                                    </rich:panel>

                                    <div class="form-horizontal">
                                        <a4j:repeat
                                                value="#{runSoapui.runInstanceAction.currentProject.gwtProject.getCustomPropertiesToModify()}"
                                                var="customProperty">
                                            <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                                <ui:param name="id" value="customPropertyUsedInput"/>
                                                <ui:define name="label">#{customProperty.label}</ui:define>
                                                <h:inputText id="customPropertyUsedInput"
                                                             value="#{customProperty.getCustomPropertyUsedByExecution(runSoapui.getExecution()).value}"
                                                             required="true" styleClass="form-control"/>
                                            </ui:decorate>
                                        </a4j:repeat>
                                        <a4j:repeat
                                                value="#{runSoapui.getCurrentProject().gwtProject.getTestSuitesWithCustomPropertiesToModify(runSoapui.componentToExecute)}"
                                                var="testSuite">
                                            <s:div>
                                                <h4>#{testSuite.label}</h4>
                                                <a4j:repeat value="#{testSuite.getCustomPropertiesToModify()}"
                                                            var="customProperty">
                                                    <ui:decorate
                                                            template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                                        <ui:param name="id" value="nameInput"/>
                                                        <ui:define name="label">#{customProperty.label}</ui:define>
                                                        <h:inputText id="nameInput"
                                                                     value="#{customProperty.getCustomPropertyUsedByExecution(runSoapui.getExecution()).value}"
                                                                     required="false"
                                                                     styleClass="form-control"/>
                                                    </ui:decorate>
                                                </a4j:repeat>
                                                <a4j:repeat
                                                        value="#{testSuite.getTestCasesWithCustomPropertiesToModify()}"
                                                        var="testCase">
                                                    <s:div>
                                                        <strong>#{testCase.label}</strong>
                                                        <a4j:repeat value="#{testCase.getCustomPropertiesToModify()}"
                                                                    var="customProperty">
                                                            <ui:decorate
                                                                    template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                                                <ui:param name="id" value="nameInput"/>
                                                                <ui:define name="label">#{customProperty.label}
                                                                </ui:define>
                                                                <h:inputText id="nameInput"
                                                                             value="#{customProperty.getCustomPropertyUsedByExecution(runSoapui.getExecution()).value}"
                                                                             required="false"
                                                                             styleClass="form-control"/>
                                                            </ui:decorate>
                                                        </a4j:repeat>
                                                    </s:div>
                                                </a4j:repeat>
                                            </s:div>
                                        </a4j:repeat>
                                    </div>
                                </gri:panel>
                            </s:div>
                        </s:div>
                    </s:div>
                    <f:facet name="footer">
                        <s:div id="footerDiv">
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.webservice.tester.GetProperties']}" action="#{runSoapui.getAllInfo()}"
                                               styleClass="gzl-btn-orange" render="formProject"
                                               rendered="#{runSoapui.isRunInstance() == true and runSoapui.runInstanceAction.execution == null and runSoapui.isFileExist()}"/>
                            <h:commandButton value="#{messages['net.ihe.gazelle.webservice.tester.Run']}" action="#{runSoapui.redirectToResult()}"
                                             styleClass="gzl-btn-blue" onclick="gazelleStatusStart();"
                                             rendered="#{runSoapui.isRunInstance() == true and runSoapui.runInstanceAction.execution != null and runSoapui.isFileExist()}"/>
                            <h:commandButton value="#{messages['net.ihe.gazelle.webservice.tester.Run']}" action="#{runSoapui.redirectToResultTest()}"
                                             styleClass="gzl-btn-blue" onclick="gazelleStatusStart();"
                                             rendered="#{runSoapui.isRunInstance() == false and runSoapui.getComponentToExecute() != null and runSoapui.isFileExist()}"/>
                            <a4j:commandButton id="resetButton" styleClass="gzl-btn" value="#{messages['net.ihe.gazelle.simulators.Reset']}"
                                               actionListener="#{runSoapui.reset()}" render="formProject"
                                               execute="@this"/>
                        </s:div>
                    </f:facet>

                </gri:panel>

            </h:form>
        </s:div>


    </ui:define>
</ui:composition>
